#include "ParticleSystemCuda.h"


#include<iostream>
using namespace std;


ParticleSystemCuda::ParticleSystemCuda(int numParticle)
{
	this->numParticle = numParticle;
	initialize();
}

void ParticleSystemCuda::initialize()
{
	
	h_pos = new float[numParticle*3];
	h_force = new float[numParticle*3];

	memset(h_pos, 0, numParticle*3*sizeof(float));
    memset(h_force, 0, numParticle*3*sizeof(float));

	allocateParticleArrays(d_pos, numParticle);
	allocateParticleArrays(d_force, numParticle);

	randomize();

	copyArrayToDevice(d_pos, h_pos, numParticle);
}



void ParticleSystemCuda::finalize()
{
	delete [] h_pos;
    delete [] h_force;

    deleteParticleArrays(d_pos);
	deleteParticleArrays(d_force);
}

ParticleSystemCuda::~ParticleSystemCuda()
{
	finalize();
}

void ParticleSystemCuda::update()
{
	computeParticle(d_pos, d_force, numParticle, 64, 4);
	copyArrayFromDevice(h_pos, d_pos, numParticle);
}

void ParticleSystemCuda::randomize()
{
	float* vec = new float[3];
	double PI = 3.14159265;

	for(int i=0; i<numParticle; ++i)
	{

		float theta = rand()%360;
		float phi = rand()%360;
		float radius = 1;

		vec[0] = float(radius * cos(theta * (PI/180.0))  * cos(phi * (PI/180.0)));
		vec[1] = float(radius * cos(theta * (PI/180.0))  * sin(phi * (PI/180.0)));
		vec[2] = float(radius * sin(theta * (PI/180.0)));

		h_pos[i*3]		= vec[0];
		h_pos[i*3+1]	= vec[1];
		h_pos[i*3+2]	= vec[2];
	}
}
