#ifndef __PARTICLESYSTEMCUDA_H__
#define __PARTICLESYSTEMCUDA_H__

#include <math.h>
#include <stdlib.h>
#include <memory.h>

extern "C"
{
	void cudaInit(int argc, char **argv);
	void allocateParticleArrays(float* vec, int numParticle);
	void deleteParticleArrays(float* vec);
	void copyArrayFromDevice(float* host, const float* device, int numParticle);
	void copyArrayToDevice(float* device, const float* host, int numParticle);

	void computeParticle(float* pos,float* force, int numParticle, int p, int q);
}

class ParticleSystemCuda
{
private:
	int numParticle;

	float* h_pos;
	float* h_force;

	float* d_pos;
	float* d_force;

public:
	ParticleSystemCuda(int numParticle);
	~ParticleSystemCuda();
	void update();

	void randomize();

	void initialize();
	void finalize();
};

#endif